--
-- MPOwner
--
-- @author  ANDR55, Destroileur
-- Version 3.0
-- @date 20.10.2017

MPOwner = {};

source(g_currentModDirectory.."MPOwnerEvent.lua");
source(g_currentModDirectory.."MPOwnerRefreshEvent.lua");
source(g_currentModDirectory.."MPOwner_ui.lua");

local esl_directory = g_currentModDirectory;

function MPOwner.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function MPOwner:load(xmlFile)
	-- print("## DEBUG MPOwner:load");
	self.MPOwner = {};
	self.MPOwner.ownerID = "";
end;

function MPOwner:delete()
	-- print("## DEBUG MPOwner:delete");
end;

function MPOwner:deleteMap()
	-- print("## DEBUG MPOwner:deleteMap");
end;

function MPOwner:readStream(streamId, connection)
	
end;

function MPOwner:readUpdateStream(streamId, timestamp, connection)

end

function MPOwner:writeStream(streamId, connection)
	
end;

function MPOwner:writeUpdateStream(streamId, connection, dirtyMask)

end

function MPOwner:mouseEvent(posX, posY, isDown, isUp, button)

end;

function MPOwner:keyEvent(unicode, sym, modifier, isDown)

end;

function MPOwner:updateTick(dt)

end;


function MPOwner:update(dt)

	
	if self.MPOwner == nil then
		self.MPOwner = {}
	end
	
	if not self.MPOwner.initialize then
		-- print("## DEBUG self.MPOwner.initialize");
		g_client:getServerConnection():sendEvent(MPOwnerRefreshEvent:new(self));
		self.MPOwner.initialize = true;
	end;
	
	if self == g_currentMission.controlledVehicle then

		MPOwner_ui.currentInVehicle = true;
	
		if not (MPOwner_ui.ownerID == self.MPOwner.ownerID) then
			MPOwner_ui:checkPriceUsage();
			MPOwner_ui.ownerID = self.MPOwner.ownerID;
			MPOwner_ui.parent = self;
			MPOwner_ui.canPopup = true;
			MPOwner_ui:refresh();
		end;

		if self.isActive then
			if self:getIsActiveForInput() then
			
				if (MPOwner_ui.canEdit or g_currentMission:getIsServer() or g_currentMission.isMasterUser) then
					if InputBinding.hasEvent(InputBinding.EDIT) then
						MPOwner_ui:enterMenu();
					end;
					g_currentMission:addHelpButtonText(g_i18n:getText("input_EDIT"), InputBinding.EDIT);
				end;
				
				-- if InputBinding.hasEvent(InputBinding.MPOWNER_CHANGE) then
					-- local user = ""
					-- if self.MPOwner.ownerID ~= self.controllerName then
						-- user = self.controllerName
					-- end;
					-- g_client:getServerConnection():sendEvent(MPOwnerEvent:new(self, user));
				-- end;
			
				-- if self.MPOwner.ownerID == "" then
					-- g_currentMission:addHelpButtonText(g_i18n:getText("input_MPOWNER_CHANGE").." "..g_i18n:getText("MPOWNER_CHANGE_NOBODY"), InputBinding.MPOWNER_CHANGE);
				-- else
					-- g_currentMission:addHelpButtonText(g_i18n:getText("input_MPOWNER_CHANGE").." "..Utils.getNoNil(self.MPOwner.ownerID, g_i18n:getText("MPOWNER_CHANGE_NOBODY")), InputBinding.MPOWNER_CHANGE);
				-- end;
				
			end;
		end;
	end;
	
end;

function MPOwner:draw()
end;


function MPOwner:load(savegame)

	-- print("MPOwner:loadFromAttributesAndNodes");
	if self.MPOwner == nil then
		self.MPOwner = {}
	end
	if asyncCallbackFunction ~= nil then
	else
		if savegame ~= nil then
			if hasXMLProperty(savegame.xmlFile, savegame.key.."#ownerID") then
				local valueStr = getXMLString(savegame.xmlFile, savegame.key.."#ownerID");
				if valueStr ~= nil then
					self.MPOwner.ownerID = valueStr;
				end;
			end;
		end;
	end;
	if self.MPOwner.ownerID == nil then
		if (g_currentMission:getIsServer() or g_currentMission.isMasterUser) then
			--self.MPOwner.ownerID = getDate("%y%m%d%H%M%S").."MR"..math.random(1000,9999);
			self.MPOwner.ownerID = getDate("%y%m%d%H%M%S").."II"..MPOwner_ui.incID;
			MPOwner_ui.incID = MPOwner_ui.incID + 1;
		else
			self.MPOwner.ownerID = -1;
		end;
	end
	self.getIsActiveForInput = Utils.overwrittenFunction(self.getIsActiveForInput, MPOwner.getIsActiveForInput);
	return BaseMission.VEHICLE_LOAD_OK;
	
end;

function MPOwner:getSaveAttributesAndNodes(nodeIdent)
	-- print("MPOwner:getSaveAttributesAndNodes");
	local attributes = 'ownerID="'..Utils.getNoNil(self.MPOwner.ownerID,"")..'"';
    return attributes, nil;
end;


function MPOwner:getIsActiveForInput(superFunc, onlyTrueIfSelected, activeIfIngameMessageShown)
    if not self.isAttachable then
        return superFunc(self, onlyTrueIfSelected, activeIfIngameMessageShown);
    else
        if g_gui:getIsGuiVisible() or g_currentMission.isPlayerFrozen then
            return false;
        end
        if self.isEntered then
            if self.attacherVehicle ~= nil then
                return true;
            else
                return (not self.steerableNeedsAttacherVehicle) and (not self.isHired);
            end
        end
	        return false;
    end
end
