--
-- MPOwner
--
-- @author  ANDR55, Destroileur
-- Version 3.0
-- @date 20.10.2017

MPOwnerEvent = {};
MPOwnerEvent_mt = Class(MPOwnerEvent, Event);
InitEventClass(MPOwnerEvent, "MPOwnerEvent");

function MPOwnerEvent:emptyNew()
	-- print("## DEBUG MPOwnerEvent:emptyNew");
	local self = Event:new(MPOwnerEvent_mt);
	return self;
end;

function MPOwnerEvent:new(vehicle, owner)
	-- print("## DEBUG MPOwnerEvent:new");
	local self = MPOwnerEvent:emptyNew();
	self.vehicle = vehicle;
	self.ownerID = owner;
  
	return self;
end;

function MPOwnerEvent:readStream(streamId, connection)
	-- print("## DEBUG MPOwnerEvent:readStream");
	local id = streamReadInt32(streamId)
	self.vehicle = networkGetObject(id);
	self.ownerID = streamReadString(streamId);
 
	self:run(connection);
end;

function MPOwnerEvent:writeStream(streamId, connection)
	-- print("## DEBUG MPOwnerEvent:writeStream");
	local id = networkGetObjectId(self.vehicle)
	streamWriteInt32(streamId, id);
	streamWriteString(streamId, Utils.getNoNil(self.ownerID, ""));
end;

function MPOwnerEvent:run(connection)
	-- print("## DEBUG MPOwnerEvent:run");
	if not connection:getIsServer() then
		-- print("## DEBUG not connection:getIsServer()");
		g_server:broadcastEvent(self, true);
	else
		-- print("## DEBUG connection:getIsServer()");
		if self.vehicle ~= nil then

			if self.vehicle.MPOwner == nil then
				self.vehicle.MPOwner = {};
				self.vehicle.MPOwner.ownerID = "";
			end;
			
			if self.vehicle.MPOwner.ownerID == nil then
				self.vehicle.MPOwner.ownerID = "";
			end;

			-- print("## DEBUG Actual owner:");
			-- print(self.vehicle.MPOwner.ownerID);
			-- print("## DEBUG New owner:");
			-- print(self.ownerID);
			self.vehicle.MPOwner.ownerID = self.ownerID;

		end;
	end;
end;