--
-- MPOwner
--
-- @author  ANDR55, Destroileur
-- Version 3.0
-- @date 20.10.2017

MPOwner_2 = {};

tab = ""
msg = ""


function MPOwner_2.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function MPOwner_2:keyEvent(unicode, sym, modifier, isDown)
end;

function MPOwner_2:mouseEvent(posX, posY, isDown, isUp, button)
end;

function MPOwner_2:update(dt)
end;

function MPOwner_2:draw()
end;

function MPOwner_2:resolveKey()
	if InputBinding.hasEvent(InputBinding.SWITCH_VEHICLE_BACK) then
		tab = "backtab";
	elseif InputBinding.hasEvent(InputBinding.SWITCH_VEHICLE) then
		tab = "tab";
	elseif InputBinding.hasEvent(InputBinding.ENTER) then
		tab = "e";
	else
		tab = "";
	end;
end;



function MPOwner_2:new(object, controllerName, playerIndex, playerColorIndex)

	-- print("## DEBUG MPOwner_2:new");
	
	self.playerIndex = playerIndex;
	self.playerColorIndex = playerColorIndex;

	local lfd_nummer;
	local ok = false;
	
	MPOwner_2:resolveKey();
	
	local i = 0;
	
	for vehicle = 1, table.getn(g_currentMission.steerables) do
		local veh = g_currentMission.steerables[vehicle];
		if networkGetObjectId(veh) == networkGetObjectId(object) then
			lfd_nummer = vehicle;
		end;
	end;

	i = lfd_nummer;
	
	local first = true;
	
	if tab == "e" then
	
		local veh = g_currentMission.steerables[i];
		
		if veh.MPOwner == nil or veh.MPOwner.canUse == nil or veh.MPOwner.canUse or g_currentMission:getIsServer() or g_currentMission.isMasterUser then
			ok = true;
		else
			g_currentMission:showBlinkingWarning(g_i18n:getText("MPOWNER_OWNER_WARNING"), 2000);
		end;
	elseif tab == "tab" or tab == "backtab" then	
		while ok == false do

			if tab == "tab" then
				if i > table.getn(g_currentMission.steerables) then
					i = 1;
				end;
			elseif tab == "backtab" then
				if i < 1 then
					i = table.getn(g_currentMission.steerables);
				end;		
			end;
			
			if i == lfd_nummer and first == false then
				break;
			end;
			
			local veh = g_currentMission.steerables[i];
			if (veh.MPOwner == nil or veh.MPOwner.canUse == nil or veh.MPOwner.canUse and veh.configFileName ~= "data/vehicles/steerable/lizard/golfCart.xml") then
				if not veh.isControlled then
					ok = true;
					break;
				end
			end;
			
			if tab == "tab" then
				i = i + 1;
			else
				i = i - 1;
			end;
			
			if first == true then
				first = false;
			end;
		end;
	else
		local veh = g_currentMission.steerables[i];
		if veh.MPOwner == nil or veh.MPOwner.canUse == nil or veh.MPOwner.canUse then
			ok = true;
		end;
	end;
	
	if ok == true then
		local self = VehicleEnterRequestEvent:emptyNew();
		self.object = g_currentMission.steerables[i];
		self.objectId = networkGetObjectId(self.object);
		self.controllerName = controllerName;
		return self;
	else
		local self = VehicleEnterRequestEvent:emptyNew();
		self.object = "nix";
		self.objectId = 1;
		self.controllerName = "";
		return self;		
	end;

	
end;

function MPOwner_2:emptyNew()
	-- print("## DEBUG MPOwner_2:emptyNew");
    local self = Event:new(VehicleEnterRequestEvent_mt);
    return self;
end;


function MPOwner_2:run_VehicleEnterRequestEvent(connection)

	-- print("## DEBUG MPOwner_2:run_VehicleEnterRequestEvent");
	if self.object ~= nil and self.object ~= "nix" then
		if connection ~= nil then
			if self.object.isControlled == false then
				self.object:setOwner(connection);
			    g_server:broadcastEvent(VehicleEnterResponseEvent:new(self.objectId, false, self.controllerName, self.playerIndex, self.playerColorIndex), true, connection, self.object);
			    connection:sendEvent(VehicleEnterResponseEvent:new(self.objectId, true, self.controllerName, self.playerIndex, self.playerColorIndex));
			   -- do not call onEnter twice on the server
				if not self.object.isEntered then
					self.object:onEnter(false);
				end;
			end;
		end;
	end;
end;

function MPOwner_2:loadMap(name)

	-- print("## DEBUG MPOwner_2:loadMap");

	VehicleEnterRequestEvent.new = MPOwner_2.new
	VehicleEnterRequestEvent.run = MPOwner_2.run_VehicleEnterRequestEvent
	
end;

function MPOwner_2:deleteMap()
	-- print("## DEBUG MPOwner_2:deleteMap");
end;

function MPOwner_2:delete()
	-- print("## DEBUG MPOwner_2:delete");
end;

addModEventListener(MPOwner_2);
